package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.DefaultTableCellRenderer;

import com.connor.jd.plm.table.CTMap;
import com.connor.jd.plm.table.CTable;
import com.connor.jd.plm.table.JCheckPanel;
import com.connor.jd.plm.table.JRadioPanel;
import com.connor.jd.plm.table.MyCellEditor;
import com.connor.jd.plm.table.TCTableUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.stylesheet.AbstractRendering;

public class SampleConfirmationForm extends AbstractRendering {
	private AbstractAIFApplication app = AIFUtility.getCurrentApplication();
	private TCComponentForm form;
	private TCSession session;
	private CardLayout cl = new CardLayout();
	private JPanel center = null;
	private JPopupMenu menu = new JPopupMenu();
	private JPopupMenu menu2 = new JPopupMenu();
	private JPanel confirmPanel = new JPanel();
	private JPanel examinePanel = new JPanel();
	private CTMap model;
	private CTMap model2;
	private CTable table;
	private CTable table2;
	private int top = 13;// ͷ
	private int bottom;// м䲿ֽ
	private int end = 14;// β+1
	private int top2 = 4;
	private int bottom2;
	private int end2 = 16;
	private Map<String, String> prop;
	private Map<String, int[]> general;
	private List<String> disableEdit;
	private Map<String, int[]> pic;
	private Map<String, int[]> general2;
	private List<String> disableEdit2;
	private JRadioPanel sysl;
	private JCheckPanel mqjd;
	String[] colNames = { "jd2_no", "jd2_gg", "jd2_gg1", "jd2_gc", "jd2_gc1",
			"jd2_1", "jd2_2", "jd2_3", "jd2_4", "jd2_5", "jd2_6", "jd2_7",
			"jd2_8", "jd2_9", "jd2_10", "jd2_min", "jd2_max", "jd2_jg" };

	public SampleConfirmationForm(TCComponent arg0) throws Exception {
		super(arg0);

		if (arg0 instanceof TCComponentForm) {
			this.form = (TCComponentForm) arg0;
			this.session = (TCSession) app.getSession();
			loadRendering();
		}
	}

	@Override
	public void loadRendering() throws TCException {
		setLayout(new BorderLayout());
		JPanel root = new JPanel(new BorderLayout());
		root.setPreferredSize(new Dimension(800, 600));
		// ͷ
		JPanel buttons = new JPanel(new FlowLayout(FlowLayout.LEFT));
		JButton confirm = new JButton("Ʒȷϵ");
		JButton examine = new JButton("CTQ");

		confirm.addActionListener(confirm());
		examine.addActionListener(examine());
		buttons.add(confirm);
		buttons.add(examine);

		// 
		center = new JPanel(cl);

		// ȷϵ
		confirmPanel.setBorder(BorderFactory.createLineBorder(Color.black, 1));
		confirmPanel.setLayout(new BorderLayout());

		// 
		model = new CTMap(47, 20);
		bottom = model.getRowCount() - end;
		disableEdit = new ArrayList<>();// ༭
		general = new HashMap<String, int[]>();// Ҫдһ
		pic = new HashMap<String, int[]>();// ͼƬ
		model.setValueAt("Ʒȷϵ", 0, 0);
		disableEdit.add("0,0");
		model.setValueAt("ύ", 0, 14);
		disableEdit.add("0,14");
		model.setValueAt("", 0, 16);
		disableEdit.add("0,16");
		model.setValueAt("׼", 0, 18);
		disableEdit.add("0,18");
		model.setValueAt("", 2, 0);
		disableEdit.add("2,0");
		model.setValueAt("Ͳз", 2, 2);
		disableEdit.add("2,2");
		general.put("jd2_bz", new int[] { 2, 14 });
		disableEdit.add("2,14");
		general.put("jd2_sh", new int[] { 2, 16 });
		disableEdit.add("2,16");
		general.put("jd2_pz", new int[] { 2, 18 });
		disableEdit.add("2,18");
		model.setValueAt("", 4, 0);
		disableEdit.add("4,0");
		general.put("creation_date", new int[] { 4, 2 });
		disableEdit.add("4,2");
		model.setValueAt("", 4, 5);
		disableEdit.add("4,5");
		general.put("owning_user", new int[] { 4, 7 });
		disableEdit.add("4,7");
		general.put("jd2_bzrq", new int[] { 4, 14 });
		disableEdit.add("4,14");
		general.put("jd2_shrq", new int[] { 4, 16 });
		disableEdit.add("4,16");
		general.put("jd2_pzrq", new int[] { 4, 18 });
		disableEdit.add("4,18");
		model.setValueAt("", 6, 0);
		disableEdit.add("6,0");
		general.put("jd2_ljm", new int[] { 6, 2 });
		general.put("jd2_ljywm", new int[] { 6, 5 });
		model.setValueAt("ͺ", 6, 8);
		disableEdit.add("6,8");
		general.put("jd2_xh", new int[] { 6, 10 });
		model.setValueAt("", 6, 14);
		disableEdit.add("6,14");
		general.put("jd2_fl", new int[] { 6, 17 });
		model.setValueAt("ϱ", 7, 0);
		disableEdit.add("7,0");
		general.put("jd2_wlbm", new int[] { 7, 2 });
		model.setValueAt("", 7, 8);
		disableEdit.add("7,8");
		sysl = new JRadioPanel(new String[] { "3", "5", "10", "30" });
		model.setValueAt(sysl, 7, 10);
		model.setValueAt("״̬", 7, 14);
		disableEdit.add("7,14");
		general.put("jd2_zt", new int[] { 7, 17 });
		model.setValueAt("Ʒȼ", 8, 0);
		disableEdit.add("8,0");
		general.put("jd2_bpdj", new int[] { 8, 2 });
		model.setValueAt("ο", 8, 8);
		disableEdit.add("8,8");
		model.setValueAt("jd2_ckwl", 8, 10);
		general.put("jd2_ckwl", new int[] { 8, 10 });
		model.setValueAt("ͼ", 9, 0);
		disableEdit.add("9,0");
		general.put("jd2_th", new int[] { 9, 2 });
		model.setValueAt("", 10, 0);
		disableEdit.add("10,0");
		general.put("jd2_gg", new int[] { 10, 2 });
		model.setValueAt("Ӧ", 11, 0);
		disableEdit.add("11,0");
		general.put("jd2_gys", new int[] { 11, 2 });
		model.setValueAt("ԭ", 9, 8);
		disableEdit.add("9,8");
		general.put("jd2_syyy", new int[] { 9, 10 });
		model.setValueAt("Ŀǰ׶", 12, 0);
		disableEdit.add("12,0");
		mqjd = new JCheckPanel(
				new String[] { "DV", "PV", "PR", "SR", "ֳ", "MP" });
		model.setValueAt(mqjd, 12, 2);

		model.setValueAt("No", top, 0);
		disableEdit.add(top + ",0");
		model.setValueAt("ߴ֤", top, 1);
		disableEdit.add(top + ",1");
		model.setValueAt("ݣ#Ʒ/ǻţ", top, 7);
		disableEdit.add(top + ",7");
		model.setValueAt("", top, 19);
		disableEdit.add(top + ",19");
		model.setValueAt("", top + 1, 1);
		disableEdit.add(top + 1 + ",1");
		model.setValueAt("", top + 1, 5);
		disableEdit.add(top + 1 + ",5");
		for (int i = 1; i < 11; i++) {
			model.setValueAt("#" + i, top + 1, i + 6);
			disableEdit.add(top + 1 + "," + (i + 6));
		}
		model.setValueAt("Min", top + 1, 17);
		disableEdit.add(top + 1 + ",17");
		model.setValueAt("Max", top + 1, 18);
		disableEdit.add(top + 1 + ",18");

		for (int i = top + 2; i <= bottom; i++) {
			model.setValueAt(i - 1 - top, i, 0);
			disableEdit.add(i + ",0");
			model.combine(new int[] { i }, new int[] { 2, 3, 4 });
		}

		model.setValueAt("ΪCTQĳߴǳҪ", bottom + 1, 0);// ӡײʼ
		disableEdit.add(bottom + 1 + ",0");
		model.setValueAt("SPL Picture", bottom + 2, 0);
		pic.put("jd2_ypzp", new int[] { bottom + 3, 0 });
		disableEdit.add(bottom + 2 + ",0");
		model.setValueAt("ע", bottom + 2, 4);
		disableEdit.add(bottom + 2 + ",4");
		model.setValueAt("C/Time", bottom + 2, 5);
		disableEdit.add(bottom + 2 + ",5");
		model.setValueAt("ע", bottom + 2, 6);
		disableEdit.add(bottom + 2 + ",6");
		model.setValueAt("ȴ", bottom + 2, 7);
		disableEdit.add(bottom + 2 + ",7");
		model.setValueAt("װ", bottom + 2, 8);
		disableEdit.add(bottom + 2 + ",8");
		model.setValueAt("Լ챨", bottom + 2, 9);
		disableEdit.add(bottom + 2 + ",9");
		model.setValueAt("ҵָ", bottom + 2, 12);
		disableEdit.add(bottom + 2 + ",12");
		model.setValueAt("QCͼ", bottom + 2, 15);
		disableEdit.add(bottom + 2 + ",15");
		model.setValueAt("ϰװǩ", bottom + 2, 18);
		disableEdit.add(bottom + 2 + ",18");
		general.put("jd2_CTime", new int[] { bottom + 3, 5 });
		general.put("jd2_zs", new int[] { bottom + 3, 6 });
		general.put("jd2_lq", new int[] { bottom + 3, 7 });
		general.put("jd2_baoz", new int[] { bottom + 3, 8 });
		pic.put("jd2_gfzjbg", new int[] { bottom + 3, 9 });
		pic.put("jd2_gfzyzds", new int[] { bottom + 3, 12 });
		pic.put("jd2_gfqcgct", new int[] { bottom + 3, 15 });
		pic.put("jd2_wlbzjbg", new int[] { bottom + 3, 18 });
		model.setValueAt("Shot/24Hr", bottom + 4, 5);
		disableEdit.add(bottom + 4 + ",5");
		model.setValueAt("", bottom + 4, 6);
		disableEdit.add(bottom + 4 + ",6");
		general.put("jd2_Shot24Hr", new int[] { bottom + 5, 5 });
		general.put("jd2_d", new int[] { bottom + 5, 6 });
		model.setValueAt("3D", bottom + 6, 4);
		disableEdit.add(bottom + 6 + ",4");
		model.setValueAt("jd2_3dzl", bottom + 6, 5);
		general.put("jd2_3dzl", new int[] { bottom + 6, 5 });
		model.setValueAt("עܹ", bottom + 6, 7);
		disableEdit.add(bottom + 6 + ",7");
		model.setValueAt("IQC׼챨", bottom + 6, 9);
		disableEdit.add(bottom + 6 + ",9");
		model.setValueAt("Ա", bottom + 6, 12);
		disableEdit.add(bottom + 6 + ",12");
		model.setValueAt("ʱ", bottom + 6, 15);
		disableEdit.add(bottom + 6 + ",15");
		model.setValueAt("ģ߱ʶ", bottom + 6, 18);
		disableEdit.add(bottom + 6 + ",18");
		pic.put("jd2_gytj", new int[] { bottom + 7, 7 });
		pic.put("jd2_iqcsjbg", new int[] { bottom + 7, 9 });
		pic.put("jd2_csbg", new int[] { bottom + 7, 12 });
		pic.put("jd2_czbf", new int[] { bottom + 7, 15 });
		pic.put("jd2_mjbs", new int[] { bottom + 7, 18 });
		model.setValueAt("ʵ", bottom + 8, 4);
		disableEdit.add(bottom + 8 + ",4");
		general.put("jd2_sczl", new int[] { bottom + 8, 5 });
		model.setValueAt("IQCҵָ", bottom + 10, 4);
		disableEdit.add(bottom + 10 + ",4");
		pic.put("jd2_icqjyzyzds", new int[] { bottom + 11, 4 });
		model.setValueAt("", bottom + 12, 12);
		disableEdit.add(bottom + 12 + ",12");
		general.put("jd2_jued", new int[] { bottom + 12, 15 });
		pic.put("jd2_qtbg", new int[] { bottom + 10, 7 });

		// ϲԪ
		model.combine(new int[] { 0, 1 },
				new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 });
		model.combine(new int[] { 0, 1 }, new int[] { 14, 15 });
		model.combine(new int[] { 0, 1 }, new int[] { 16, 17 });
		model.combine(new int[] { 0, 1 }, new int[] { 18, 19 });
		model.combine(new int[] { 2, 3 }, new int[] { 0, 1 });
		model.combine(new int[] { 2, 3 },
				new int[] { 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 });
		model.combine(new int[] { 2, 3 }, new int[] { 14, 15 });
		model.combine(new int[] { 2, 3 }, new int[] { 16, 17 });
		model.combine(new int[] { 2, 3 }, new int[] { 18, 19 });
		model.combine(new int[] { 4, 5 }, new int[] { 0, 1 });
		model.combine(new int[] { 4, 5 }, new int[] { 2, 3, 4 });
		model.combine(new int[] { 4, 5 }, new int[] { 5, 6 });
		model.combine(new int[] { 4, 5 },
				new int[] { 7, 8, 9, 10, 11, 12, 13 });
		model.combine(new int[] { 4, 5 }, new int[] { 14, 15 });
		model.combine(new int[] { 4, 5 }, new int[] { 16, 17 });
		model.combine(new int[] { 4, 5 }, new int[] { 18, 19 });
		model.combine(new int[] { 6 }, new int[] { 0, 1 });
		model.combine(new int[] { 6 }, new int[] { 2, 3, 4 });
		model.combine(new int[] { 6 }, new int[] { 5, 6, 7 });
		model.combine(new int[] { 6 }, new int[] { 8, 9 });
		model.combine(new int[] { 6 }, new int[] { 10, 11, 12, 13 });
		model.combine(new int[] { 6 }, new int[] { 14, 15, 16 });
		model.combine(new int[] { 6 }, new int[] { 17, 18, 19 });
		model.combine(new int[] { 7 }, new int[] { 0, 1 });
		model.combine(new int[] { 7 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 7 }, new int[] { 8, 9 });
		model.combine(new int[] { 7 }, new int[] { 10, 11, 12, 13 });
		model.combine(new int[] { 7 }, new int[] { 14, 15, 16 });
		model.combine(new int[] { 7 }, new int[] { 17, 18, 19 });
		model.combine(new int[] { 8 }, new int[] { 0, 1 });
		model.combine(new int[] { 8 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 8 }, new int[] { 8, 9 });
		model.combine(new int[] { 8 },
				new int[] { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { 9 }, new int[] { 0, 1 });
		model.combine(new int[] { 9 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 9, 10, 11 }, new int[] { 8, 9 });
		model.combine(new int[] { 9, 10, 11 },
				new int[] { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { 10 }, new int[] { 0, 1 });
		model.combine(new int[] { 10 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 11 }, new int[] { 0, 1 });
		model.combine(new int[] { 11 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 12 }, new int[] { 0, 1 });
		model.combine(new int[] { 12 }, new int[] { 2, 3, 4, 5, 6, 7, 8, 9, 10,
				11, 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { top, 1 }, new int[] { 0 });
		model.combine(new int[] { top }, new int[] { 1, 2, 3, 4, 5, 6 });
		model.combine(new int[] { top },
				new int[] { 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 });
		model.combine(new int[] { top, top + 1 }, new int[] { 19 });
		model.combine(new int[] { top + 1 }, new int[] { 1, 2, 3, 4 });
		model.combine(new int[] { top + 1 }, new int[] { 5, 6 });
		model.combine(new int[] { bottom + 1 }, new int[] { 0, 1, 2, 3, 4, 5 });
		model.combine(new int[] { bottom + 2 }, new int[] { 0, 1 });
		model.combine(new int[] { bottom + 2 }, new int[] { 2, 3 });
		model.combine(
				new int[] { bottom + 3, bottom + 4, bottom + 5, bottom + 6,
						bottom + 7, bottom + 8, bottom + 9, bottom + 10,
						bottom + 11, bottom + 12, bottom + 13 },
				new int[] { 0, 1, 2, 3 });
		model.combine(
				new int[] { bottom + 2, bottom + 3, bottom + 4, bottom + 5 },
				new int[] { 4 });
		model.combine(new int[] { bottom + 2 }, new int[] { 9, 10, 11 });
		model.combine(new int[] { bottom + 2 }, new int[] { 12, 13, 14 });
		model.combine(new int[] { bottom + 2 }, new int[] { 15, 16, 17 });
		model.combine(new int[] { bottom + 2 }, new int[] { 18, 19 });
		model.combine(new int[] { bottom + 4, bottom + 5 }, new int[] { 7, 8 });
		model.combine(new int[] { bottom + 3, bottom + 4, bottom + 5 },
				new int[] { 9, 10, 11 });
		model.combine(new int[] { bottom + 3, bottom + 4, bottom + 5 },
				new int[] { 12, 13, 14 });
		model.combine(new int[] { bottom + 3, bottom + 4, bottom + 5 },
				new int[] { 15, 16, 17 });
		model.combine(new int[] { bottom + 3, bottom + 4, bottom + 5 },
				new int[] { 18, 19 });
		model.combine(new int[] { bottom + 6, bottom + 7 }, new int[] { 4 });
		model.combine(new int[] { bottom + 8, bottom + 9 }, new int[] { 4 });
		model.combine(new int[] { bottom + 6, bottom + 7 }, new int[] { 5 });
		model.combine(new int[] { bottom + 8, bottom + 9 }, new int[] { 5 });
		model.combine(
				new int[] { bottom + 6, bottom + 7, bottom + 8, bottom + 9 },
				new int[] { 6 });
		model.combine(new int[] { bottom + 6 }, new int[] { 7, 8 });
		model.combine(new int[] { bottom + 6 }, new int[] { 9, 10, 11 });
		model.combine(new int[] { bottom + 6 }, new int[] { 12, 13, 14 });
		model.combine(new int[] { bottom + 6 }, new int[] { 15, 16, 17 });
		model.combine(new int[] { bottom + 6 }, new int[] { 18, 19 });
		model.combine(new int[] { bottom + 7, bottom + 8, bottom + 9 },
				new int[] { 7, 8 });
		model.combine(new int[] { bottom + 7, bottom + 8, bottom + 9 },
				new int[] { 9, 10, 11 });
		model.combine(new int[] { bottom + 7, bottom + 8, bottom + 9 },
				new int[] { 12, 13, 14 });
		model.combine(new int[] { bottom + 7, bottom + 8, bottom + 9 },
				new int[] { 15, 16, 17 });
		model.combine(new int[] { bottom + 7, bottom + 8, bottom + 9 },
				new int[] { 18, 19 });
		model.combine(new int[] { bottom + 10 }, new int[] { 4, 5, 6 });
		model.combine(new int[] { bottom + 11, bottom + 12, bottom + 13 },
				new int[] { 4, 5, 6 });
		model.combine(new int[] { bottom + 10, bottom + 11, bottom + 12,
				bottom + 13 }, new int[] { 7, 8, 9, 10, 11 });
		model.combine(new int[] { bottom + 10, bottom + 11 },
				new int[] { 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { bottom + 12, bottom + 13 },
				new int[] { 12, 13, 14 });
		model.combine(new int[] { bottom + 12, bottom + 13 },
				new int[] { 15, 16, 17, 18, 19 });

		table = new CTable(model) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (isEditorDisable(disableEdit, row, col)) {
					return false;
				}
				return true;
			}
		};
		table.setRowHeight(25);
		table.setBorder(BorderFactory.createLineBorder(Color.black));
		table.getColumnModel().getColumn(0).setPreferredWidth(40);
		table.getColumnModel().getColumn(1).setPreferredWidth(60);
		table.getColumnModel().getColumn(2).setPreferredWidth(50);
		table.getColumnModel().getColumn(3).setPreferredWidth(50);
		table.getColumnModel().getColumn(4).setPreferredWidth(50);
		table.getColumnModel().getColumn(5).setPreferredWidth(60);
		table.getColumnModel().getColumn(6).setPreferredWidth(60);
		for (int i = 7; i < model.getColumnCount() - 1; i++) {
			table.getColumnModel().getColumn(i).setPreferredWidth(45);
		}
		table.getColumnModel().getColumn(model.getColumnCount() - 1)
				.setPreferredWidth(80);
		DefaultTableCellRenderer tcr1 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table,
					Object value, boolean isSelected, boolean hasFocus, int row,
					int column) {
				// TODO Auto-generated method stub

				if (value instanceof JLabel) {
					return (JLabel) value;
				}

				if (value instanceof JPanel) {
					return (JPanel) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(),
							0);
					maxPreferredHeight = Math.max(maxPreferredHeight,
							getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr1.setHorizontalAlignment(SwingConstants.CENTER);
		table.setDefaultRenderer(Object.class, tcr1);
		for (int i = 0; i < model.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i)
					.setCellEditor(new MyCellEditor(new JTextField()));
		}
		table.addMouseListener(rightClick());
		confirmPanel.add(table, BorderLayout.CENTER);

		// д
		prop = form.getProperties();
		for (Entry<String, int[]> entry : general.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				model.setValueAt(prop.get(entry.getKey()), entry.getValue()[0],
						entry.getValue()[1]);
			} else {
				model.setValueAt(entry.getKey(), entry.getValue()[0],
						entry.getValue()[1]);
				System.out.println("ԡ" + entry.getKey() + "δҵ");
			}
		}
		if (prop.containsKey("jd2_sysl")) {
			sysl.setSelected(prop.get("jd2_sysl"));
		}
		if (prop.containsKey("jd2_mqjd")) {
			mqjd.setSelected(prop.get("jd2_mqjd"));
		}
		pic.put("user_data_1", new int[] { bottom + 3, 0 });
		pic.put("user_data_2", new int[] { bottom + 3, 9 });
		for (Entry<String, int[]> entry : pic.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				TCComponent comp = null;
				try {
					comp = session.stringToComponent(prop.get(entry.getKey()));
					if (comp != null) {
						TCComponentDataset dataset = (TCComponentDataset) comp;
						String temp = System.getenv("temp");
						System.out.println(temp);
						String[] types = dataset.getProperty("ref_names")
								.split(",");
						System.out.println(Arrays.toString(types));
						System.out.println(Arrays
								.toString(dataset.getFileNames(types[0])));
						File img = dataset.getFiles(types[0], temp)[0];
						System.out.println(img.getPath());

						ImageIcon icon = new ImageIcon(img.getPath());
						int row = entry.getValue()[0];
						int col = entry.getValue()[1];
						int[] arr = model.getSpan(row, col);
						int width = 0;
						for (int i = 0; i < arr[1]; i++) {
//							width+=table.getColumnModel().getColumn()
						}
						System.out.println("row:" + arr[0] + ",col:" + arr[1]);
						icon.setImage(icon.getImage().getScaledInstance(
								table.getColumnModel().getColumn(col)
										.getPreferredWidth() * arr[1],
								table.getRowHeight() * arr[0],
								Image.SCALE_SMOOTH));
						JLabel label = new JLabel();
						label.setLayout(new FlowLayout(FlowLayout.CENTER));
						label.setIcon(icon);
						label.addMouseListener(showImg(img.getPath()));
						label.setToolTipText(dataset.getUid());
						model.setValueAt(label, row, col);
					}
				} catch (Exception e) {
					e.printStackTrace(System.out);
				}

			} else {
				model.setValueAt(new JLabel(entry.getKey()),
						entry.getValue()[0], entry.getValue()[1]);
				System.out.println("ԡ" + entry.getKey() + "δҵ");
			}
		}
		if (prop.containsKey("jd2_ypqrdtable")) {
			String[][] tableRows = TCTableUtil.getTableRows(form,
					"jd2_ypqrdtable", colNames);
			System.out.println(Arrays.deepToString(tableRows));
			for (int i = 0; i < tableRows.length; i++) {
				for (int ii = 0; ii < tableRows[0].length; ii++) {
					if (i + top + 2 > bottom) {
						int num = Integer.parseInt(
								model.getValueAt(bottom, 0).toString());
						model.insertRow(bottom);
						model.setValueAt(num + 1, bottom, 0);
						model.combine(new int[] { bottom },
								new int[] { 2, 3, 4 });
						bottom = model.getRowCount() - end;
					}
					model.setValueAt(tableRows[i][ii], i + top + 2,
							ii > 2 ? ii + 2 : ii);
				}
			}
		}

		ScrollPane confirmScrollPanel = new ScrollPane();
		confirmScrollPanel.add(confirmPanel);
		// 
		examinePanel.setBorder(BorderFactory.createLineBorder(Color.black, 1));
		examinePanel.setLayout(new BorderLayout());

		model2 = new CTMap(49, 10);
		bottom2 = model2.getRowCount() - end2;
		model2.setValueAt("SPL No", 0, 0);
		disableEdit2.add("0,0");
		model2.combine(new int[] { 0, 1, 2, 3 }, new int[] { 0 });
		model2.setValueAt(" SPEC", 0, 1);
		disableEdit2.add("0,1");
		model2.combine(new int[] { 0, 1 }, new int[] { 1 });
		for (int i = 0; i < 8; i++) {
			model2.setValueAt("CTQ<" + i + 1 + ">", 0, i + 2);
			disableEdit2.add("0," + (i + 2));
		}
		model2.setValueAt("LOW", 2, 1);
		disableEdit2.add("2,1");
		model2.setValueAt("UP", 3, 1);
		disableEdit2.add("3,1");

		for (int i = top2; i <= model2.getRowCount(); i++) {
			model2.setValueAt(i - top2, i, 0);
			disableEdit2.add(i + ",0");
			model2.combine(new int[] { i }, new int[] { 0, 1 });
		}
		model2.setValueAt("MIN", bottom + 1, 0);
		model2.setValueAt("MAX", bottom + 2, 0);
		model2.setValueAt("R", bottom + 3, 0);
		model2.setValueAt("׼ƫ", bottom + 4, 0);
		model2.setValueAt("ƽ", bottom + 5, 0);
		model2.setValueAt("X,BAR-3S", bottom + 6, 0);
		model2.setValueAt("X,BAR+3S", bottom + 7, 0);
		model2.setValueAt("CP", bottom + 8, 0);
		model2.setValueAt("Cpu", bottom + 9, 0);
		model2.setValueAt("Cpl", bottom + 10, 0);
		model2.setValueAt("CPK", bottom + 11, 0);
		model2.setValueAt("SU Ԥⲻ", bottom + 12, 0);
		model2.setValueAt("SL Ԥⲻ", bottom + 13, 0);
		model2.setValueAt("Ԥⲻ(PPM)", bottom + 14, 0);
		model2.setValueAt("", bottom + 15, 0);

		table2 = new CTable(model2) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (isEditorDisable(disableEdit2, row, col)) {
					return false;
				}
				return true;
			}
		};
		table2.setRowHeight(25);
		table2.setBorder(BorderFactory.createLineBorder(Color.black));
		for (int i = 0; i < model.getColumnCount(); i++) {
			table2.getColumnModel().getColumn(i).setPreferredWidth(80);
		}
		DefaultTableCellRenderer tcr2 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table,
					Object value, boolean isSelected, boolean hasFocus, int row,
					int column) {
				// TODO Auto-generated method stub
				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(),
							0);
					maxPreferredHeight = Math.max(maxPreferredHeight,
							getPreferredSize().height);
				}
				setBackground(Color.white);
//		if(points1.contains(new Point(row,column)))
//			setForeground(new Color(0,0,255));
//		else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr2.setHorizontalAlignment(SwingConstants.CENTER);
		table2.setDefaultRenderer(Object.class, tcr2);
		table2.addMouseListener(rightClick2());
		examinePanel.add(table2, BorderLayout.CENTER);

		ScrollPane examineScrollPanel = new ScrollPane();
		examineScrollPanel.add(examinePanel);

		// ȷϵҼ˵
		menu.setVisible(false);
		JMenuItem addP;
		addP = new JMenuItem("ͼƬ");
		menu.add(addP);
		addP.addActionListener(addPic());
		JMenuItem addR;
		addR = new JMenuItem("");
		menu.add(addR);
		addR.addActionListener(addRow());
		JMenuItem insertR;
		insertR = new JMenuItem("");
		menu.add(insertR);
		insertR.addActionListener(insertRow());

		// 鵥Ҽ˵
		menu2.setVisible(false);
		JMenuItem addR2;
		addR2 = new JMenuItem("");
		menu2.add(addR2);
		addR2.addActionListener(addRow2());
		JMenuItem insertR2;
		insertR2 = new JMenuItem("");
		menu2.add(insertR2);
		insertR2.addActionListener(insertRow2());

		center.add("confirm", confirmScrollPanel);
		center.add("examine", examineScrollPanel);
		root.add(buttons, BorderLayout.NORTH);
		root.add(center, BorderLayout.CENTER);
		this.add(menu);
		this.add(root, BorderLayout.CENTER);

		center.add("confirm", confirmScrollPanel);
		center.add("examine", examineScrollPanel);
		root.add(buttons, BorderLayout.NORTH);
		root.add(center, BorderLayout.CENTER);
		this.add(menu);
		this.add(root, BorderLayout.CENTER);

		cl.show(center, "confirm");
	}

	@Override
	public void saveRendering() {
		// ͼƬ
		JLabel label = null;
		for (Entry<String, int[]> entry : pic.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				label = (JLabel) model.getValueAt(entry.getValue()[0],
						entry.getValue()[1]);
				try {
					form.setProperty(entry.getKey(), label.getToolTipText());
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}
		// ѡ
		try {
			if (prop.containsKey("jd2_sysl")) {
				form.setProperty("jd2_sysl", sysl.getSelected() == null ? ""
						: sysl.getSelected().getText());
			}
			if (prop.containsKey("jd2_mqjd")) {
				form.setProperty("jd2_mqjd", mqjd.getSelectedText() == null ? ""
						: mqjd.getSelectedText());
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// ͨ
		for (Entry<String, int[]> entry : general.entrySet()) {
			try {
				if (prop.containsKey(entry.getKey())) {
					form.setProperty(entry.getKey(),
							model.getValueAt(entry.getValue()[0],
									entry.getValue()[1]).toString());
				}
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// 
		if (prop.containsKey("jd2_ypqrdtable")) {
			List<String[]> data = new ArrayList<String[]>();
			int num = 0;
			while (model.getValueAt(top + 2 + num, 1) != null
					&& !"".equals(model.getValueAt(top + 2 + num, 1))) {
				String[] row = new String[18];
				for (int ii = 0; ii < 18; ii++) {
					Object object = model.getValueAt(top + 2 + num,
							ii > 2 ? ii + 2 : ii);
					if (object == null) {
						row[ii] = "";
					} else {
						row[ii] = object.toString();
					}
					System.out.println(row[ii]);
				}
				data.add(row);
				num++;
			}
			String[][] dataArr = data.toArray(new String[data.size()][]);
			System.out.println(Arrays.deepToString(dataArr));
			TCTableUtil.setTableRows(form, "jd2_ypqrdtable", colNames, dataArr);
		}

	}

	private ActionListener confirm() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				System.out.println("confirm");
				cl.show(center, "confirm");
			}
		};
		return actionListener;
	}

	private ActionListener examine() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				System.out.println("examine");
				cl.show(center, "examine");
			}
		};
		return actionListener;
	}

	private MouseAdapter rightClick() {
		MouseAdapter mouseAdapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON3 && form.isCheckedOut()
						&& table.getSelectedRow() != -1) {
					menu.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		};
		return mouseAdapter;
	}

	private MouseAdapter rightClick2() {
		MouseAdapter mouseAdapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON3 && form.isCheckedOut()
						&& table2.getSelectedRow() != -1) {
					menu2.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		};
		return mouseAdapter;
	}

	private ActionListener addPic() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				JFileChooser fileChooser = new JFileChooser();
				fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				fileChooser.setMultiSelectionEnabled(false);
				fileChooser.setFileFilter(new FileFilter() {

					@Override
					public String getDescription() {
						// TODO Auto-generated method stub
						return "(ͼƬ)*.png;*.jpg;*.jpeg;*.bmp;";
					}

					@Override
					public boolean accept(File var1) {
						// TODO Auto-generated method stub
						return var1.getName().endsWith(".png")
								|| var1.getName().endsWith(".jpg")
								|| var1.getName().endsWith(".jpeg")
								|| var1.getName().endsWith(".bmp");
					}
				});
				fileChooser.showOpenDialog(menu);// ʾλ
				File file = fileChooser.getSelectedFile();
				if (file != null) {
					System.out.println("fileName:" + file.getName());
					String as1[] = { file.getPath() };// ļ·
					String as2[] = { "Image" };
					TCComponentDatasetType datasetType;
					try {
						datasetType = (TCComponentDatasetType) session
								.getTypeComponent("Dataset");
						TCComponentDataset dataset = datasetType
								.create(file.getName(), "", "Image");
						dataset.setFiles(as1, as2);
						TCComponent[] comps = form.getRelatedComponents();
						AIFComponentContext[] ref = form.whereReferenced();
						TCComponentItemRevision rev = (TCComponentItemRevision) ref[0]
								.getComponent();
						rev.add("IMAN_specification", dataset);
						String uid = dataset.getUid();
						System.out.println("uid:" + uid);
						ImageIcon icon = new ImageIcon(file.getPath());
						int row = table.getSelectedRow();
						int col = table.getSelectedColumn();
						int[] arr = model.getSpan(row, col);
						System.out.println("row:" + arr[0] + ",col:" + arr[1]);
						icon.setImage(icon.getImage().getScaledInstance(
								table.getColumnModel().getColumn(col)
										.getPreferredWidth() * arr[1],
								table.getRowHeight() * arr[0],
								Image.SCALE_SMOOTH));
						JLabel label = new JLabel();
						label.setLayout(new FlowLayout(FlowLayout.CENTER));
						label.setIcon(icon);
						label.addMouseListener(showImg(file.getPath()));
						label.setToolTipText(uid);
						model.setValueAt(label, table.getSelectedRow(),
								table.getSelectedColumn());
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
		};

		return actionListener;
	}

	private ActionListener addRow() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table.getSelectedRow();
				if (row > top + 1 && row < bottom + 1) {
					int num = Integer
							.parseInt(model.getValueAt(bottom, 0).toString());
					model.insertRow(bottom);
					model.setValueAt(num + 1, bottom, 0);
					model.combine(new int[] { bottom }, new int[] { 2, 3, 4 });
					bottom = model.getRowCount() - end;
				} else {
					// ʾ
				}
			}
		};
		return actionListener;
	}

	private ActionListener addRow2() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table2.getSelectedRow();
				if (row >= top2 && row <= bottom2) {
					int num = Integer
							.parseInt(model2.getValueAt(bottom2, 0).toString());
					model2.insertRow(bottom2);
					model2.setValueAt(num + 1, bottom2, 0);
					model2.combine(new int[] { bottom2 }, new int[] { 0, 1 });
					bottom2 = model2.getRowCount() - end2;
				} else {
					// ʾ
				}
			}
		};
		return actionListener;
	}

	private ActionListener insertRow() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table.getSelectedRow();
				if (row > top + 1 && row < bottom + 1) {
					int num = Integer
							.parseInt(model.getValueAt(row, 0).toString());
					model.insertRow(row);
					for (int i = row; i < model.getRowCount(); i++) {
						model.setValueAt(num + i + 1 - row, row, 0);
					}
					model.combine(new int[] { row }, new int[] { 2, 3, 4 });
					bottom = model.getRowCount() - end;
				} else {
					// ʾ
				}
			}
		};
		return actionListener;
	}

	private ActionListener insertRow2() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table2.getSelectedRow();
				if (row >= top2 && row <= bottom2) {
					int num = Integer
							.parseInt(model2.getValueAt(row, 0).toString());
					model2.insertRow(row);
					for (int i = row; i < model2.getRowCount(); i++) {
						model2.setValueAt(num + i + 1 - row, row, 0);
					}
					model2.combine(new int[] { row }, new int[] { 0, 1 });
					bottom2 = model2.getRowCount() - end2;
				} else {
					// ʾ
				}
			}
		};
		return actionListener;
	}

	private boolean isEditorDisable(List<String> list, int row, int col) {
		return list.contains(row + "," + col);
	}

	private MouseAdapter showImg(String path) {
		final String imagePath = path;
		MouseAdapter adapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2) {
					PhotoFrame.getInstance(imagePath);
				}
			}
		};
		return adapter;
	}
}
