package com.connor.jd.plm.table;

import java.awt.Component;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JTable;

import com.teamcenter.rac.util.DateButton;

public class ButtonEditor2 extends DefaultCellEditor {

	protected DateButton button;
	private String label;
	private boolean isPushed;

	public ButtonEditor2(JCheckBox checkBox) {
		super(checkBox);
		button = new DateButton();
		
	}

	public Component getTableCellEditorComponent(JTable table, Object value, 
			boolean isSelected, int row, int column) {
		if (isSelected) {
			button.setForeground(table.getSelectionForeground());
			button.setBackground(table.getSelectionBackground());
		} else {
			button.setForeground(table.getForeground());
			button.setBackground(table.getBackground());
		}
		
		return button;
	}

	public Object getCellEditorValue() {
		//yyyyMMdd HH:mm
		SimpleDateFormat format=new SimpleDateFormat("HH:mm");
		Date data = new Date();
		System.out.println("ccc===>"+format.format(data));		
		
		return format.format(button.getDate());
	}


}
